﻿
// Classe renderEngine (V1).
// F Heintz (www.fredHeintz.com)

// Renders Mesh geometrie.

import _engine3DAS.mesh
import _engine3DAS.vertex
import _engine3DAS.polygon

class _engine3DAS.renderEngine
{
private	var _zDepth:Number;
private var _displayClipRef:MovieClip;
	
	// ----------------------------------------------------------------------------------------------------------------
	// Constructor
	public function renderEngine(displayClip:MovieClip, zDepth:Number)
	{
		_zDepth = zDepth;
		_displayClipRef = displayClip;
		for(var i:Number = 0; i < _zDepth; i++)
		{
			_displayClipRef.createEmptyMovieClip(String(i), 100 + _zDepth - i);
		}
	}
	
	// 
	public function startNewFrame():Void
	{
		for(var i:Number = 0; i < _zDepth; i++)
		{
			_displayClipRef[i].clear();
		}
	}
	
	// Render the mesh on a movieClip
	public function renderMesh(meshObj:mesh):Void
	{
	var	i:Number;
	var	j:Number;
	var	nbIndexs:Number;
	var	vertexIndex:Number;
	var	vertexObj:vertex;
	var	polygonObj:polygon;
	var	zIndex:Number;
	var	zAveraged:Number;
	var	zRangeClip:MovieClip;
	var	indexList:Array;
	var	vertexList:Array;

		var zQ:Number = _zDepth / (1000.0 - 10.0);
		vertexList = meshObj._vertexList;
		for(i = 0; i < meshObj._nbPolygons; i++)
		{
			polygonObj = meshObj._polygonList[i];			
			if(polygonObj._bVisible != true)
			{
				continue;
			}			
			nbIndexs = polygonObj._nbIndexs;
			indexList = polygonObj._indexList;
			
			// z range
			zAveraged = 0.0;
			for(j = 0; j < nbIndexs; j++)
			{
				vertexIndex = indexList[j];
				vertexObj = vertexList[vertexIndex];				
				zAveraged += vertexObj._w;
			}
			zIndex = -Math.floor((zAveraged / nbIndexs) * zQ);
			if(zIndex > (_zDepth - 1))
			{
				// Too far.
				continue;
			}
			if(zIndex < 0)		zIndex = 0;
			zRangeClip = _displayClipRef[zIndex];
			
			// Draw the polygon
			zRangeClip.beginFill(polygonObj._color, 100);
			for(j = 0; j < nbIndexs; j++)
			{
				vertexIndex = indexList[j];
				vertexObj = vertexList[vertexIndex];				
				if(j == 0)
				{
					// first vertex of the polygon
					zRangeClip.moveTo(vertexObj._x2D, vertexObj._y2D);
				}
				else
				{
					// other vertex of the polygon
					zRangeClip.lineTo(vertexObj._x2D, vertexObj._y2D);
				}
			}
			zRangeClip.endFill();
		}		
	}

	// Render the vertexs of the mesh (as movieClips).
	public function renderMeshVertexs(meshObj:mesh, theGraph:MovieClip):Void
	{
	var scale:Number;
	var	vertexObj:vertex;
	
		for(var i:Number = 0; i < meshObj._nbVertexs; i++)
		{
			vertexObj = meshObj._vertexList[i];				
			theGraph[i]._visible = true;
			theGraph[i]._x = vertexObj._x2D;
			theGraph[i]._y = vertexObj._y2D;
			scale = 100.0 / vertexObj._z;
			theGraph[i]._xscale = scale;
			theGraph[i]._yscale = scale;
		}
	}
	
	// Hides the movieClips used to display the vertexs of the mesh.
	public function hideMeshVertexs(meshObj:mesh, theGraph:MovieClip):Void
	{
		for(var i:Number = 0; i < meshObj._nbVertexs; i++)
		{
			theGraph[i]._visible = false;
		}
	}
}














